#!/usr/bin/env python
# -*- coding:utf-8 -*- 


##############################################################################
## license :
##============================================================================
##
## File :        DonkiPlayerServer.py
## 
## Project :     DonkiOrchestra Player Device
##
## This file is part of Tango device class.
## 
## Tango is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## Tango is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with Tango.  If not, see <http://www.gnu.org/licenses/>.
## 
##
## $Author :      sci.comp$
##
## $Revision :    $
##
## $Date :        $
##
## $HeadUrl :     $
##============================================================================
##            This file is generated by POGO
##    (Program Obviously used to Generate tango Object)
##
##        (c) - Software Engineering Group - ESRF
##############################################################################

"""DonkiOrchestra Player Device"""

__all__ = ["DonkiPlayerServer", "DonkiPlayerServerClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(DonkiPlayerServer.additionnal_import) ENABLED START -----#
from PlayerBgndThread  import processThread
import traceback

#----- PROTECTED REGION END -----#	//	DonkiPlayerServer.additionnal_import

## Device States Description
## No states for this device

class DonkiPlayerServer (PyTango.Device_4Impl):

    #--------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(DonkiPlayerServer.global_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.global_variables

    def __init__(self,cl, name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        DonkiPlayerServer.init_device(self)
        #----- PROTECTED REGION ID(DonkiPlayerServer.__init__) ENABLED START -----#
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(DonkiPlayerServer.delete_device) ENABLED START -----#
        self.pt._alive = False
        self.pt.join()
        del self.pt
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        self.attr_trigger_read = 0
        self.attr_action_log_read = ''
        #----- PROTECTED REGION ID(DonkiPlayerServer.init_device) ENABLED START -----#
        self.pt = processThread(self.nickname, self.InfoServer, self.ActionCode)
        self.pt.start()
        self.set_state(PyTango.DevState.STANDBY)
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(DonkiPlayerServer.always_executed_hook) ENABLED START -----#
        if self.pt._seq_started:
            if self.get_state() != PyTango.DevState.ON:
                self.set_state(PyTango.DevState.ON)
        elif self.get_state() != PyTango.DevState.STANDBY:
            self.set_state(PyTango.DevState.STANDBY)

        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.always_executed_hook

    #-----------------------------------------------------------------------------
    #    DonkiPlayerServer read/write attribute methods
    #-----------------------------------------------------------------------------
    
    def read_trigger(self, attr):
        self.debug_stream("In read_trigger()")
        #----- PROTECTED REGION ID(DonkiPlayerServer.trigger_read) ENABLED START -----#
        self.attr_ack_read = self.pt.last_trg
        attr.set_value(self.attr_ack_read)
        
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.trigger_read
        
    def read_action_log(self, attr):
        self.debug_stream("In read_action_log()")
        #----- PROTECTED REGION ID(DonkiPlayerServer.action_log_read) ENABLED START -----#
        self.attr_action_log_read = self.pt.lastlog
        attr.set_value(self.attr_action_log_read)
        
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.action_log_read
        
    
    
        #----- PROTECTED REGION ID(DonkiPlayerServer.initialize_dynamic_attributes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.initialize_dynamic_attributes
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(DonkiPlayerServer.read_attr_hardware) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.read_attr_hardware


    #-----------------------------------------------------------------------------
    #    DonkiPlayerServer command methods
    #-----------------------------------------------------------------------------
    

class DonkiPlayerServerClass(PyTango.DeviceClass):
    #--------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(DonkiPlayerServer.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.global_class_variables

    def dyn_attr(self, dev_list):
        """Invoked to create dynamic attributes for the given devices.
        Default implementation calls
        :meth:`DonkiPlayerServer.initialize_dynamic_attributes` for each device
    
        :param dev_list: list of devices
        :type dev_list: :class:`PyTango.DeviceImpl`"""
    
        for dev in dev_list:
            try:
                dev.initialize_dynamic_attributes()
            except:
                import traceback
                dev.warn_stream("Failed to initialize dynamic attributes")
                dev.debug_stream("Details: " + traceback.format_exc())
        #----- PROTECTED REGION ID(DonkiPlayerServer.dyn_attr) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	DonkiPlayerServer.dyn_attr

    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'InfoServer':
            [PyTango.DevString,
            "`HOSTNAME:PORT` of the DonkiOrchestra Info Server",
            ["localhost:50010"] ],
        'ActionCode':
            [PyTango.DevString,
            "Filepath of the Python code that will be executed as the trigger arrives",
            [] ],
        'nickname':
            [PyTango.DevString,
            "DonkiOrchestra Player Nickname",
            ["nicky"] ],
        }


    #    Command definitions
    cmd_list = {
        }


    #    Attribute definitions
    attr_list = {
        'trigger':
            [[PyTango.DevLong,
            PyTango.SCALAR,
            PyTango.READ]],
        'action_log':
            [[PyTango.DevString,
            PyTango.SCALAR,
            PyTango.READ]],
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(DonkiPlayerServerClass,DonkiPlayerServer,'DonkiPlayerServer')

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print ('-------> Received a DevFailed exception: %s' % str(e))
    except Exception as e:
        print ('-------> An unforeseen exception occured....%s' % str(e))

if __name__ == '__main__':
    main()
